IncludeFile "OthelloEngine.pbi"


Enumeration
  #window
  #screen
  #but_neustart
  #but_rueckgang
  #but_loadpartie
  #cursor
  #text_zaehler
  #file_partie
  #window_media
  #but_media_next
  #but_media_back
  #imgg_render
  #img_render
EndEnumeration

CreateImage(#img_render, 500, 500)
OpenWindow(#window,300,300,650,500,"Othello",#PB_Window_SystemMenu | #PB_Window_MinimizeGadget)

StartDrawing(WindowOutput(#window))
CreateGadgetList(WindowID(#window))
  s.s = "Neustart"
  x.l = 510
  y.l = 20
  w.l = TextWidth(s) + 10
  h.l = TextHeight(s) + 10
  ButtonGadget(#but_neustart,x, y, w, h, s)
  s = ""
  y + h + 20
  h = 50
  TextGadget(#text_zaehler, x, y, 650 - x, h, s)
  s = "Undo"
  y + h + 20
  w = TextWidth(s) + 10
  h = TextHeight(s) + 10
  ButtonGadget(#but_rueckgang, x, y, w, h, s)
  s = "Load Game"
  y + h + 20
  w = TextWidth(s) + 10
  h = TextHeight(s) + 10
  ButtonGadget(#but_loadpartie, x, y, w, h, s)
  ImageGadget(#imgg_render, 0, 0, 500, 500, ImageID(#img_render))
StopDrawing()


Procedure MediaBox()
  OpenWindow(#window_media,177,300,110,50,"Replay",#PB_Window_SystemMenu | #PB_Window_MinimizeGadget)
  CreateGadgetList(WindowID(#window_media))
    ButtonGadget(#but_media_next,5,5,45,40,"Next")
    ButtonGadget(#but_media_back,65,5,45,40,"Back")
EndProcedure

Procedure LoadPartie()
  name.s = OpenFileRequester("Partie Laden","","Textfile |*.txt",0)
  If name
    If OpenFile(#file_partie,name)
      ReadData(#file_partie, @replay2(),8 * 8 * SizeOf(replay))
      CloseFile(#file_partie)
      init()
      MediaBox()
      replay_zaehler = 0
      play_zaehler   = 0
    EndIf
  EndIf
  
EndProcedure

Procedure DrawBrett() 
  Protected x.l, y.l
  
  StartDrawing(ImageOutput(#img_render))
  For y = 0 To 7
    For x = 0 To 7
      If brett(x,y) = #spieler1
        Circle(x * 62.5 + 31.25, y * 62.5 + 31.25, 28, $FFFFFF)
      ElseIf brett(x,y) = #spieler2
        Circle(x * 62.5 + 31.25, y * 62.5 + 31.25, 28, 0)
      EndIf
    Next
  Next
  
  DrawingMode(4)
  ForEach zuege()
    
    If zuege()\spieler = #spieler1
      Circle(zuege()\x * 62.5 + 31.25, zuege()\y * 62.5 + 31.25, 29, $FF)
    ElseIf zuege()\spieler = #spieler2
      Circle(zuege()\x * 62.5 + 31.25, zuege()\y * 62.5 + 31.25, 30, $FFFF)
    EndIf
  Next
  DrawingMode(0)
  StopDrawing()
EndProcedure


Procedure DrawGrid()
  StartDrawing(ImageOutput(#img_render))
    Box(0, 0, 500, 500, RGB(0, 150, 0))
    Repeat
      x.f + 62.5
      Line(x,0,0,500,0)
    Until x >= 500
    Repeat 
      y.f + 62.5
      Line(0,y,500,0,0)
    Until y >= 500
  StopDrawing()
EndProcedure

Procedure Events()
  Shared Quit, ende, mx, my, mbut
  Protected setx.l, sety.l, setspieler.b
  mx    = 0
  my    = 0
  mbut  = 0
  
  zaehler(@steine.zaehler)
  SetGadgetText(#text_zaehler,"Spieler: " + Str(steine\sp1) + Chr(10) + "Computer: " + Str(steine\sp2))
  
  event = WaitWindowEvent()
  If event
    Select event
      Case #PB_Event_CloseWindow
        If EventWindow() = #window
          Quit = 1
        ElseIf IsWindow(#window_media) And EventWindow() = #window_media
          CloseWindow(#window_media)
        EndIf
      Case #PB_Event_Gadget
        GadgetID.l = EventGadget()
        Select GadgetID
          Case #imgg_render
            If EventType() = #PB_EventType_LeftClick
              mx   = WindowMouseX(#window)
              my   = WindowMouseY(#window)
              mbut = #True
            EndIf
            
          Case #but_neustart
            init()
            DrawGrid()
            DrawBrett()
            SetGadgetState(#imgg_render, ImageID(#img_render))
            
          Case #but_rueckgang
            If CountList(rueckgang()) > 1
              CopyMemory(@rueckgang(),@brett(),8 * 8)
              DeleteElement(rueckgang())
              LastElement(rueckgang())
              ClearList(zuege())
              If ende
                ende = 0
              EndIf
            EndIf
            DrawGrid()
            DrawBrett()
            SetGadgetState(#imgg_render, ImageID(#img_render))
            
          Case #but_loadpartie
            LoadPartie()
            DrawGrid()
            DrawBrett()
            SetGadgetState(#imgg_render, ImageID(#img_render))
            
          Case #but_media_next
            play_zaehler + 1
            replay_zaehler = play_zaehler
            
            init()
            For z = 1 To play_zaehler
              For z1 = 0 To 7
                For z2 = 0 To 7
                  If replay2(z1,z2)\zugnummer = z
                    setx = z1
                    sety = z2
                    setspieler = replay2(z1,z2)\spieler
                  EndIf
                Next
              Next
              setzen(setx,sety,setspieler)
            Next
            ClearList(zuege())
            DrawGrid()
            DrawBrett()
            SetGadgetState(#imgg_render, ImageID(#img_render))
            
          Case #but_media_back
            play_zaehler - 1
            If play_zaehler < 0
              play_zaehler = 0
            EndIf
            replay_zaehler = play_zaehler
            
            init()
            For z = 1 To play_zaehler
              For z1 = 0 To 7
                For z2 = 0 To 7
                  If replay2(z1,z2)\zugnummer = z
                    setx = z1
                    sety = z2
                    setspieler = replay2(z1,z2)\spieler
                  EndIf
                Next
              Next
              setzen(setx,sety,setspieler)
            Next
            ClearList(zuege())
            DrawGrid()
            DrawBrett()
            SetGadgetState(#imgg_render, ImageID(#img_render))
            
        EndSelect
    EndSelect
  EndIf
EndProcedure

Procedure Legen(mx,my)
  Shared gelegt
  
  ClearList(zuege())
  If setzen(Int(mx / 62.5),Int(my / 62.5), #spieler1)
    gelegt = #True
  EndIf
EndProcedure

Procedure Ende()
  Shared finish1
  zaehler(@steine.zaehler)
  
  If steine\sp1 > steine\sp2
    If finish1 <> 3
      MessageRequester("Gewonnen!","Sie haben gewonnen!!!")
    Else
      MessageRequester("Gewonnen!","Wow! Sie haben mich vernichtend geschlagen!!!")
    EndIf
  ElseIf steine\sp1 = steine\sp2
    MessageRequester("Unentschieden","Das Spiel endet unentschieden")
  Else
    If finish1 <> 3
      MessageRequester("Verloren!","Sie haben verloren!!!")
    Else
      MessageRequester("Verloren!","Schmen Sie sich!!!")
    EndIf
  EndIf
EndProcedure




init()

DrawGrid()
DrawBrett()
SetGadgetState(#imgg_render, ImageID(#img_render))
Repeat
  Events()
  ; mbut, mx, my, Quit, Ende wurden gefllt
  
  If mbut
    Legen(mx,my)
    ; 'gelegt' wurde gefllt
    DrawGrid()
    DrawBrett()
    SetGadgetState(#imgg_render, ImageID(#img_render))
    While WindowEvent() : Wend
  EndIf
  
  If gelegt = #True
    Delay(200)
    gelegt    = #False
    finish2   = computerzug(#spieler2)
    firstmove = 0
    DrawGrid()
    DrawBrett()
    SetGadgetState(#imgg_render, ImageID(#img_render))
    While WindowEvent() : Wend
  EndIf
  ;{ Checkfinishes
  If ende = 0
    finish1 = check_finish(#spieler1)
    If finish1 = 0 Or (finish1 = 2 And finish2 = 2) Or finish1 = 3
      DrawGrid()
      DrawBrett()
      SetGadgetState(#imgg_render, ImageID(#img_render))
      
      zaehler(@steine.zaehler)
      SetGadgetText(#text_zaehler,"Spieler: " + Str(steine\sp1) + Chr(10) + "Computer: " + Str(steine\sp2))
      
      While WindowEvent() : Wend
      
      Ende()
      ende    = 1
      finish1 = 1
      gelegt = #False
    ElseIf finish1 = 2
      gelegt = #True
      MessageRequester("berspringen","Da sie nicht legen knnen, werden sie bersprungen!")
      
    ElseIf finish2 = 2
      MessageRequester("bersprungen","Der Computer kann nicht legen, sie sind dran!")
      
      finish2 = 1
      gelegt  = #False
    EndIf
  EndIf
  ;}
  
Until Quit



CreateFile(1,"Partie.txt")
WriteData(1, @replay(),8 * 8 * SizeOf(replay))
CloseFile(1)
; IDE Options = PureBasic 4.00 - Beta 2 (Linux - x86) - (c) 2006 Fantaisie Software
; CursorPosition = 41
; FirstLine = 20
; Folding = A+
; EnableUnicode
; SubSystem = gtk2